/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor jmenasouboru.c */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <pwd.h>
#include <string.h>
#include "definice.h"
#include "struktury.h"
#include "lib.h"

#ifndef  HELPPROGRAM_KONTROLA
char *jmeno_adresare_hlavni(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%s/%s/%s/", JMENO_ADR_LaT, NAZEV, LVERA);
    return slozka;
}
#endif
char *jmeno_temp_soubor(void)
{
    static char temp[50];
    snprintf(temp, 50, "/tmp/lock%s%s.%i", SVER, NAZEV, (int) getuid());
    return temp;
}

char *jmeno_napovedy(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%snapoveda/napoveda",
             jmeno_adresare_hlavni());
    return slozka;
}

char *jmeno_napovedy3(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%snapoveda/napoveda3",
             jmeno_adresare_hlavni());
    return slozka;
}

char *jmeno_menu(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%snapoveda/menu", jmeno_adresare_hlavni());
    return slozka;
}

char *jmeno_adresare_psani(void)
{
    static char adresar[NAME_MAX];
#ifndef FLOPPY
    struct passwd *pw;
#endif
#ifdef FLOPPY                   /* psani je umistene na bootovatelne diskete */
    snprintf(adresar, NAME_MAX, "/floppy/.%s/psani/", PBADRESAR);
#else
    pw = getpwuid(getuid());
    if (pw == NULL)
        return NULL;
    snprintf(adresar, NAME_MAX, "%s/.%s/psani/", pw->pw_dir, PBADRESAR);
#endif
    return adresar;
}

char *jmeno_adresare(void)
{
    static char adresar[NAME_MAX];
    snprintf(adresar, NAME_MAX, "%s%s/", jmeno_adresare_psani(), SVER);
    return adresar;
}

char *jmeno_souboru(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%s%s", jmeno_adresare(), JMENO_SOUBORU);
    return slozka;
}

char *jmeno_souboru_nastaveni(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%s%s", jmeno_adresare(),
             JMENO_SOUBORU_NASTAVENI);
    return slozka;
}

char *jmeno_lekce00(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%slekce/lekce00", jmeno_adresare_hlavni());
    return slozka;
}

char *jmeno_lekceXX(short int x)
{
    static char slozka[NAME_MAX];
    strncpy(slozka, jmeno_lekce00(), NAME_MAX);
    slozka[strlen(slozka) - 2] = (char) ((int) x / 10 + (int) '0');
    slozka[strlen(slozka) - 1] =
        (char) (x - ((int) x / 10) * 10 + (int) '0');
    return slozka;
}

char *jmeno_napovedy_lekce(int i)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX,
             "%snapoveda/lekce%02i", jmeno_adresare_hlavni(), i);
    return slozka;
}

char *jmeno_info_lekce(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%slekce/info", jmeno_adresare_hlavni());
    return slozka;
}

char *jmeno_testu00(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%stesty/test00", jmeno_adresare_hlavni());
    return slozka;
}

char *jmeno_testuXX(short int x)
{
    static char slozka[NAME_MAX];
    strncpy(slozka, jmeno_testu00(), NAME_MAX);
    slozka[strlen(slozka) - 2] = (char) ((int) x / 10 + (int) '0');
    slozka[strlen(slozka) - 1] =
        (char) (x - ((int) x / 10) * 10 + (int) '0');
    return slozka;
}

char *jmeno_napovedy_testu(int i)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%snapoveda/test%02i",
             jmeno_adresare_hlavni(), i);
    return slozka;
}

char *jmeno_info_testu(void)
{
    static char slozka[NAME_MAX];
    snprintf(slozka, NAME_MAX, "%stesty/info", jmeno_adresare_hlavni());
    return slozka;
}


char *jmeno_nov_text(char *nazev)
{
    static char nov_text[NAME_MAX];

    if (nazev != NULL)
        strncpy(nov_text, nazev, NAME_MAX);
    return nov_text;
}
